/*								-*- C++ -*-
 * $Id: demo.cpp,v 1.5 1997-02-28 16:02:33+01 mho Exp $
 *
 * Purpose: demo for wxWindows Xt port inclusive demo for wxCanvas
 *
 * Authors: Markus Holzem and Julian Smart
 *
 * Copyright: (C) 1995, AIAI, University of Edinburgh (Julian)
 * Copyright: (C) 1995, GNU (Markus)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define  Uses_wxApp
#define  Uses_wxButton
#define  Uses_wxCanvas
#define  Uses_wxCheckBox
#define  Uses_wxChoice
#define  Uses_wxColourDialog
#define  Uses_wxFontDialog
#define  Uses_wxFrame
#define  Uses_wxGauge
#define  Uses_wxListBox
#define  Uses_wxMenuBar
#define  Uses_wxMessage
#define  Uses_wxMetaFileDC
#define  Uses_wxMultiText
#define  Uses_wxPanel
#define  Uses_wxPostScriptDC
#define  Uses_wxPrintSetup
#define  Uses_wxRadioBox
#define  Uses_wxSlider
#define  Uses_wxText
#define  Uses_wxTextWindow
#define  Uses_wxTimer
#define  Uses_wxToolBar
#include "wx.h"
#include <math.h>

#ifdef __GNUG__
#pragma implementation "demo.h"
#endif
#include "demo.h"

//-----------------------------------------------------------------------------
// XPM files
//-----------------------------------------------------------------------------

#include "xpm/aiai.xpm"		// icon
#include "xpm/aiai.xbm"		// second icon to test zooming of bitmaps

#include "xpm/map.xpm"		// bitmap for button to move toolbar

#include "xpm/plaid.xpm"	// stipple for filling

#include "xpm/file.xpm"		// toolbar load 
#include "xpm/disk.xpm"		// toolbar save
#include "xpm/cut.xpm"		// toolbar cut
#include "xpm/copy.xpm"		// toolbar copy
#include "xpm/paste.xpm"	// toolbar paste
#include "xpm/undo.xpm"		// toolbar undo
#include "xpm/debug.xpm"	// toolbar undo
#include "xpm/clamp.xpm"        // toolbar toggle user edit mode
#include "xpm/scale.xpm"	// toolbar toggle GDI scaling for DCs

//-----------------------------------------------------------------------------
// local data
//-----------------------------------------------------------------------------

static int cursors [] = {
    wxCURSOR_ARROW, wxCURSOR_BASED_ARROW_DOWN,
    wxCURSOR_BASED_ARROW_UP, wxCURSOR_BULLSEYE,
    wxCURSOR_CROSS, wxCURSOR_CROSS_REVERSE,
    wxCURSOR_DOUBLE_ARROW, wxCURSOR_HAND,
    wxCURSOR_IBEAM, wxCURSOR_LEFT_BUTTON,
    wxCURSOR_MAGNIFIER, wxCURSOR_MIDDLE_BUTTON,
    wxCURSOR_NO_ENTRY, wxCURSOR_PAINT_BRUSH,
    wxCURSOR_PENCIL, wxCURSOR_POINT_LEFT,
    wxCURSOR_POINT_RIGHT, wxCURSOR_QUESTION_ARROW,
    wxCURSOR_RIGHT_BUTTON, wxCURSOR_SIZENESW,
    wxCURSOR_SIZENS, wxCURSOR_SIZENWSE,
    wxCURSOR_SIZEWE, wxCURSOR_SIZING,
    wxCURSOR_SPRAYCAN, wxCURSOR_WAIT,
    wxCURSOR_WATCH, wxCURSOR_CHAR,
    wxCURSOR_BLANK, 
};

static int mapmode[] = {
    MM_TWIPS, MM_LOMETRIC, MM_METRIC, MM_POINTS, MM_TEXT,
};

static float zoom_factor = 1.0;
static Bool  scale_gdi_classes = TRUE;

static char* text_fname = NULL;

static int tbar_pos = 0; // tbar_pos_circulate[0] == wxALIGN_TOP;
static int tbar_pos_circulate[] = {
    wxALIGN_TOP, wxALIGN_LEFT, wxALIGN_RIGHT, wxALIGN_BOTTOM
};

static MyApp myApp;
static HelloFrame   *hello_frame = NULL;
static HelloPanel   *hello_panel = NULL;
static wxFrame      *canvas_frame = NULL;
static MyCanvas     *canvas = NULL;
static wxTextWindow *twin = NULL;
static wxGauge      *gauge = NULL;
static MyTimer      the_timer;

static wxPen    *red_pen = NULL;
static wxBrush  *plaid_brush = NULL;
static wxFont   *canvas_font = NULL;
static wxFont   *canvas_font_underlined = NULL;
static wxFont   *textwindow_font = NULL;
static wxCursor *canvas_cursor = NULL;

static wxIcon*   aiai_icon   = NULL;
static wxIcon*	 aiai_icon2  = NULL;
static wxButton* rotate_tbar = NULL;

static void menu_callback(wxMenu& menu, wxCommandEvent& ev);

static wxMenuBar *MakeMenuBar(void);
static wxToolBar *MakeToolBar(void);

//-----------------------------------------------------------------------------
// MyApp implementation
//-----------------------------------------------------------------------------

#define C1 0
#define C2 100
#define C3 280
#define C4 380
#define LW 95
#define IW 175

wxFrame *MyApp::OnInit(void)
{
    wxButton *btn;  wxRadioBox *rbox; wxText *txt;
    wxChoice *chc;  wxCheckBox *chk;  wxMultiText *mtxt;
    wxSlider *sldr; wxListBox  *lbox;
    wxMessage *msg;
    int  xx, yy, hh, ww;
    char *choice_strings[5] = { "Arthur", "Julian", "Hattie", "Ken", "Dick" };
    char *radio_strings[6] = { "A", "B", "C", "D", "E", "F" };
    char *lbox_strings[5] = { "Apple", "Pear", "Orange", "Banana", "Fruit" };

#if DEBUG && USE_MEMORY_TRACING
    wxDebugContext::SetFile("debug_init.log");
    TRACE("+++ Start of OnInit +++\n\n");
    wxDebugContext::Dump();
    TRACE("Statistics:\n");
    wxDebugContext::PrintStatistics();
    TRACE("+++ done +++\n");
    wxDebugContext::SetCheckpoint();
#endif
    // set AFM path
    wxSetAFMPath("/home/mho/lib/afm/");
    // Create some GDI objects
    red_pen                = DEBUG_NEW wxPen("RED", 3, wxSOLID);
    canvas_font            = DEBUG_NEW wxFont(12, wxROMAN, wxNORMAL, wxNORMAL);
    canvas_font_underlined = DEBUG_NEW wxFont(12, wxROMAN, wxNORMAL, wxNORMAL,
					      TRUE);
    textwindow_font        = DEBUG_NEW wxFont(12, wxSWISS, wxNORMAL, wxNORMAL);
    aiai_icon              = DEBUG_NEW wxIcon(aiai_xpm);
    aiai_icon2             = DEBUG_NEW wxIcon(aiai_bits, aiai_width,
					      aiai_height);
    plaid_brush            = DEBUG_NEW wxBrush;
    plaid_brush->SetStyle(wxSTIPPLE);
    wxBitmap plaid_bm(plaid_xpm);
    plaid_brush->SetStipple(&plaid_bm);
    // create and init a frame
    hello_frame = DEBUG_NEW HelloFrame(NULL, wxVERSION_STRING, 0, 0, 617, 502);
    hello_frame->SetMenuBar(MakeMenuBar());
    hello_frame->SetToolBar(MakeToolBar());
    hello_frame->CreateStatusLine(2);
    hello_frame->SetStatusText("Hello, wxWindows");
    hello_frame->SetIcon(aiai_icon);
    // create panel and panel items
    hello_panel = DEBUG_NEW HelloPanel(hello_frame, 0, 0, 1000, 500);
    hello_panel->SetHorizontalMargin(5); hello_panel->SetHorizontalSpacing(5);
    hello_panel->SetVerticalMargin(3);   hello_panel->SetVerticalSpacing(3);

    // first line (button and checkbox)
    msg = DEBUG_NEW wxMessage(hello_panel, "wxButton:", C1, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    btn = DEBUG_NEW wxButton(hello_panel, NULL, "Press Me", C2, -1, IW/2, -1);
    btn->SetClientData((char*)TAG_BUTTON);
    msg = DEBUG_NEW wxMessage(hello_panel, "wxCheckBox:", C3, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    chk = DEBUG_NEW wxCheckBox(hello_panel, NULL, "Fix toolbar", C4, -1);
    chk->SetClientData((char*)TAG_CHECK);
    hello_panel->NewLine();
    // second line (choice and gauge)
    msg = DEBUG_NEW wxMessage(hello_panel, "wxChoice:", C1, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    chc = DEBUG_NEW wxChoice(hello_panel, NULL, NULL, C2, -1, IW, -1,
			     5, choice_strings);
    chc->SetClientData((char*)TAG_CHOICE);
    chc->SetSelection(0);
    msg = DEBUG_NEW wxMessage(hello_panel, "wxGauge:", C3, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    gauge = DEBUG_NEW wxGauge(hello_panel, NULL, 150, C4, -1, IW, -1,
			      wxHORIZONTAL);
    gauge->SetValue(40);
    hello_panel->NewLine();
    // third line (message and radiobox)
    msg = DEBUG_NEW wxMessage(hello_panel, "wxMessage:", C1, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    (void)DEBUG_NEW wxMessage(hello_panel, "A short message", C2);
    msg = DEBUG_NEW wxMessage(hello_panel, "wxRadioBox:", C3, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    rbox = DEBUG_NEW wxRadioBox(hello_panel, NULL, NULL, C4, -1, IW-2, -1,
				6, radio_strings, 6, wxNO_BORDER|wxHORIZONTAL);
    rbox->SetClientData((char*)TAG_RADIO);
    rbox->SetStringSelection("D");
    hello_panel->NewLine();
    // fourth line (slider and single text)
    msg = DEBUG_NEW wxMessage(hello_panel, "wxSlider:", C1, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    sldr = DEBUG_NEW wxSlider(hello_panel, NULL, NULL, 40, 22, 101, IW, C2, -1,
			      wxHORIZONTAL);
    sldr->SetClientData((char*)TAG_SLIDER);
    msg = DEBUG_NEW wxMessage(hello_panel, "wxText:", C3, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    txt = DEBUG_NEW wxText(hello_panel, NULL, NULL, "Initial value",
			   C4, -1, IW);
    txt->SetClientData((char*)TAG_SINGLETEXT);
    hello_panel->NewLine();
    // fifth line (move toolbar, listbox and multi text)
    hello_panel->GetCursor(&xx, &yy) ;// move toolbar button
    wxBitmap map_bm(map_xpm);
    btn = DEBUG_NEW wxButton(hello_panel, NULL, &map_bm, C1);
    btn->SetClientData((char*)TAG_MOVE_TBAR);
    btn->GetSize(&ww, &hh);
    btn->Move(C1, yy + 100 - hh);
    rotate_tbar = btn;
    msg = DEBUG_NEW wxMessage(hello_panel, "wxListBox:", C1, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    lbox = DEBUG_NEW wxListBox(hello_panel, NULL, NULL,
			       wxSINGLE,
			       C2, -1, IW, 100, 5, lbox_strings,
			       wxSINGLE|wxALWAYS_SB);
    lbox->SetClientData((char*)TAG_LIST);
    msg = DEBUG_NEW wxMessage(hello_panel, "wxMultiText:", C3, -1, LW, -1);
    msg->SetAlignment(wxALIGN_RIGHT);
    mtxt = DEBUG_NEW wxMultiText(hello_panel, NULL, NULL, "Some text",
				 C4, -1, IW, 100);
    // fit panel
    hello_panel->Fit();
    // text window
    twin = DEBUG_NEW wxTextWindow(hello_frame, -1, -1, 500, 250, 0);
    twin->SetFont(textwindow_font);
    twin->LoadFile(text_fname = copystring("welcome.txt"));
    // modify background colours for text items
    txt->SetBackgroundColour(*wxWHITE);
    mtxt->SetBackgroundColour(*wxWHITE);
    twin->SetBackgroundColour(*wxWHITE);
    // show the frame
    hello_frame->Show(TRUE);
    // create and init canvas_frame and canvas
    canvas_frame = DEBUG_NEW wxFrame(hello_frame, "Canvas", 629, 0, 383, 383,
				     wxDEFAULT_FRAME | wxTRANSIENT,
				     "CanvasFrame");
    canvas = DEBUG_NEW MyCanvas(canvas_frame, -1, -1, -1, -1, wxRETAINED);
    canvas->SetScrollbars(20, 20, 50, 50, 4, 4);
    canvas->SetCursor(canvas_cursor = DEBUG_NEW wxCursor(wxCURSOR_PENCIL));
    canvas->popup = DEBUG_NEW wxMenu("A little popup",
				     (wxFunction)&menu_callback);
    canvas->popup->Append(TEST_POPUP1, "First");
    canvas->popup->Append(TEST_POPUP2, "Second");
    canvas->popup->Append(TEST_POPUP3, "Third");
    // show the frame
    canvas_frame->Show(TRUE);
#if DEBUG && USE_MEMORY_TRACING
    TRACE("+++ End of OnInit +++\n\n");
    wxDebugContext::Dump();
    TRACE("Statistics:\n");
    wxDebugContext::PrintStatistics();
    TRACE("+++ done +++\n");
    wxDebugContext::SetCheckpoint();
    wxDebugContext::SetStream(DEBUG_NEW ostream(twin), twin);
#endif
    // return a frame
    return hello_frame;
}

int MyApp::OnExit(void)
{
    delete red_pen;
    delete canvas_font;
    delete canvas_font_underlined;
    delete textwindow_font;
    delete aiai_icon;
    delete aiai_icon2;
    delete plaid_brush;
    delete canvas_cursor;

    if (text_fname)
	delete text_fname;
    text_fname = NULL;

    return 0;
}

//-----------------------------------------------------------------------------
// HelloFrame implementation
//-----------------------------------------------------------------------------

void HelloFrame::OnMenuCommand(int id)
{
    wxDC *dc = canvas->GetDC();
    char *s;

    switch (id) {
    case TEST_NEW:
	if (text_fname) delete text_fname; text_fname = NULL;
	twin->LoadFile(NULL);
	break;
    case TEST_LOAD:
	if ((s = wxLoadFileSelector("text", "txt", text_fname, hello_frame))) {
	    if (text_fname) delete text_fname;
	    twin->LoadFile(text_fname = copystring(s));
	}
	break;
    case TEST_SAVE:
	if (text_fname && twin->SaveFile(text_fname))
	    break; // save successful
    case TEST_SAVEAS:
	if ((s = wxSaveFileSelector("text", "txt", text_fname, hello_frame))) {
	    if (text_fname) delete text_fname;
	    if (!twin->SaveFile(text_fname = copystring(s))) {
		char* buf = DEBUG_NEW char[strlen(text_fname)+100];
		sprintf(buf, "Failed to write\n%s!", text_fname);
		(void)wxMessageBox(buf, "Save Warning", wxOK|wxCENTRE,
				   hello_frame);
		delete buf;
	    }
	}
	break;
    case TEST_PRINTEPS:
	dc = DEBUG_NEW wxPostScriptDC(NULL, TRUE, hello_frame);
	if (dc->Ok() && dc->StartDoc("Hello printout")) {
	    dc->StartPage();
	    dc->SetUserScale(zoom_factor, zoom_factor);
	    dc->ScaleGDIClasses(scale_gdi_classes);
	    Draw(*dc, FALSE);
	    dc->EndPage();
	    dc->EndDoc();
	}
	delete dc;
	break;
    case TEST_QUIT:
	Close();
	return;
    case TEST_NORMAL:
	zoom_factor = 1.0;
	dc->SetUserScale(1.0, 1.0);
	canvas->SetScrollbars(20, 20, 50, 50, 4, 4);
	break;
    case TEST_ZOOM: {
	char *new_zoom = wxGetTextFromUser("Enter new zoom factor", "Input",
					   FloatToString(zoom_factor),
					   hello_frame);
	if (new_zoom) {
	    StringToFloat(new_zoom, &zoom_factor);
	    if (zoom_factor <= 0.0)
		zoom_factor = 1.0;
	    canvas->SetScrollbars(int(zoom_factor * 20), int(zoom_factor * 20),
				  50,                    50,
				  int(zoom_factor *  4), int(zoom_factor *  4));
	    dc->SetUserScale(zoom_factor, zoom_factor);
	    dc->ScaleGDIClasses(scale_gdi_classes);
	    dc->Clear();
	    Draw(*dc);
	}
	break;
    }
    case TEST_TIMERON:
	the_timer.Start(5000);
	GetMenuBar()->Enable(TEST_TIMERON, FALSE);
	GetMenuBar()->Enable(TEST_TIMEROFF, TRUE);
	break;
    case TEST_TIMEROFF:
	the_timer.Stop();
	GetMenuBar()->Enable(TEST_TIMERON, TRUE);
	GetMenuBar()->Enable(TEST_TIMEROFF, FALSE);
	break;
    case TEST_CHECKABLE:
        (void)wxMessageBox(
	    (GetMenuBar()->Checked(id) ? "state: Check" : "state: Uncheck"),
	    "Checkable item",
	    wxOK|wxCENTRE, hello_frame);
	break ;
    case TEST_ABOUT:
	(void)wxMessageBox(
	    "Demo for \"" wxVERSION_STRING "\"\n"
	    "Author: Markus Holzem (mho@comnets.rwth-aachen.de)\n"
	    "Markus (c) 1996 / AIAI (c) 1994",
            "About wxHello", wxOK|wxCENTRE, hello_frame);
	break;
    case TEST_CHANGE_COLOUR: {
	wxColourData data;
	data.SetChooseFull(TRUE);
	for (int i = 0; i < 16; i++) {
	    wxColour colour(i*16, i*16, i*16);
	    data.SetCustomColour(i, colour);
	}
	wxColourDialog dialog(this, &data);
	if (dialog.Show(TRUE)) {
	    wxColourData retData = dialog.GetColourData();
	    twin->SetBackgroundColour(retData.GetColour());
	}
	break; }
    case TEST_CHANGE_FONT: {
	wxFontData data;
	data.SetInitialFont(textwindow_font);
	data.SetColour(*(twin->GetForegroundColour()));
	wxFontDialog dialog(this, &data);
	if (dialog.Show(TRUE)) {
	    delete textwindow_font;
	    wxFontData retData = dialog.GetFontData();
	    twin->SetFont(textwindow_font = retData.GetChosenFont());
	    twin->SetForegroundColour(retData.GetColour());
	}
	break; }
    }
    if (TEST_TWIPS <= id && id <= TEST_NORMAL) {
	dc->SetMapMode(mapmode[id-TEST_TWIPS]);
	dc->ScaleGDIClasses(scale_gdi_classes);
	dc->Clear();
	Draw(*dc);
    }
    if (TEST_CURSOR_ARROW <= id && id <= TEST_CURSOR_BLANK) {
	canvas_cursor = DEBUG_NEW wxCursor(cursors[id-TEST_CURSOR_ARROW]);
	// set new and delete old cursor
	delete canvas->SetCursor(canvas_cursor);
    }
    SetStatusText("Hello wxWindows");
}

void HelloFrame::OnMenuSelect(int id)
{
    char *help = menubar->GetHelpString(id);

    SetStatusText(help ? help : "Hello wxWindows");
}

void HelloFrame::Draw(wxDC& dc, Bool on_canvas)
{
    dc.SetFont(canvas_font);
    dc.SetPen(wxGREEN_PEN);
    dc.SetBrush(plaid_brush);
    // two lines, a spline and a rectangle inside a square
    if (dc.IsExposed(0, 0, 200, 200)) {
	dc.DrawLine(0, 0, 200, 200);
	dc.DrawLine(200, 0, 0, 200);
	dc.SetPen(wxRED_PEN);
	dc.DrawRectangle(100, 100, 100, 50);
	dc.DrawSpline(50, 200, 50, 100, 200, 10);
    }
    // draw a rectangle with some text inside
    if (dc.IsExposed(150, 150, 100, 50)) {
	dc.SetPen(wxRED_PEN);
	dc.DrawRoundedRectangle(150, 150, 100, 50, 20);
	dc.SetClippingRegion(151, 150, 98, 50);
	dc.SetBackgroundMode(wxSOLID);
	dc.DrawText("This text should be clipped within the rectangle",
		    150, 170);
	dc.SetBackgroundMode(wxTRANSPARENT);
	dc.DestroyClippingRegion();
    }
    // draw an ellipse
    dc.SetPen(wxRED_PEN);
    dc.SetBrush(wxCYAN_BRUSH);
    if (dc.IsExposed(250, 250, 101, 51)) {
	dc.DrawRectangle(250, 250, 100, 50);
	if (zoom_factor > 1.0) {
	    dc.SetBrush(wxTRANSPARENT_BRUSH);
	    dc.StartUnzoomedDrawing(250, 250); // top left corner of rectangle
	    dc.DrawEllipse(0, 0, 100, 50);
	    dc.EndUnzoomedDrawing();
	    dc.StartUnzoomedDrawing(350, 300); // bottom right corner
	    dc.DrawEllipse(-100, -50, 100, 50);
	    dc.EndUnzoomedDrawing();
	    dc.SetBrush(wxCYAN_BRUSH);
	} else {
	    dc.DrawEllipse(250, 250, 100, 50);
	}
    }
    // to optimize text drawing you need to know something about the
    // document structure to do it efficiently
    dc.DrawLine(50, 230, 200, 230);
    dc.DrawText("This is a test string", 50, 230);
    dc.SetFont(canvas_font_underlined);
    dc.DrawText("This is an underlined string", 250, 330);
    dc.SetPen(wxBLACK_PEN);
    // draw a filled pie
    if (dc.IsExposed(50, 250, 150, 100))
	dc.DrawEllipse(50, 250, 150, 100,
		       int(64*canvas->alpha1), int(64*canvas->alpha2));
    // draw a sine curve using SetLogicalOrigin and SetAxisOrientation
    dc.SetAxisOrientation(TRUE, TRUE);
    dc.SetLogicalOrigin(340, -100);
    if (dc.IsExposed(0, 50, 150, 100)) {
	dc.DrawLine(0, -50, 0, 50); dc.DrawLine(0, 0, 150, 0);
	float x;
	for (x = 0; x < 150; x += 1)
	    dc.DrawLine(x,   50*sin(x*3.1415926535/75),
			x+1, 50*sin((x+1)*3.1415926535/75));
    }
    // reset origin and axis
    dc.SetAxisOrientation(TRUE, FALSE);
    dc.SetLogicalOrigin(0, 0);
    // draw an 8-bit and an 1-bit pixmap
    dc.DrawIcon(aiai_icon,  260, 50);
    dc.DrawIcon(aiai_icon2, 260, 120);
    // draw a ruler, if drawing on canvas and not on postscript
    if (on_canvas) {
	int i;
	for (i = 0; i < 1000; i += 50) {
	    char buf[10];
	    sprintf(buf, "%d", i);
	    dc.SetFont(canvas_font);
	    dc.DrawText(buf, (float)i, (float)400);
	}
    }
}

void HelloFrame::OnSize(int WXUNUSED(width), int WXUNUSED(height))
{
    if (hello_panel && twin) {
	int fwidth, fheight, pwidth, pheight;
	GetClientSize(&fwidth, &fheight);
	hello_panel->GetSize(&pwidth, &pheight);
	hello_panel->SetSize(0,       0, fwidth,                -1);
	twin       ->SetSize(0, pheight, fwidth, fheight - pheight);
    }
}

Bool HelloFrame::OnClose(void)
{
#if DEBUG && USE_MEMORY_TRACING
    wxDebugContext::SetFile("debug_exit.log");
#endif

    return TRUE;
}

//-----------------------------------------------------------------------------
// HelloPanel implementation
//-----------------------------------------------------------------------------

void HelloPanel::OnCommand(wxWindow &win, wxCommandEvent &event)
{
    wxItem *item = (wxItem*)&win;

    switch (long(item->GetClientData())) {
    case TAG_BUTTON:
	if (wxMessageBox("Press OK to continue", "Try me",
			 wxOK | wxCANCEL, hello_frame) == wxOK)
	{
	    char *text = wxGetTextFromUser("Enter some text", "Text input",
					   "", hello_frame);
	    if (text) {
		(void)wxMessageBox(text, "Result", wxOK, hello_frame);
		hello_frame->SetStatusText(text);
	    }
	}
	break;
    case TAG_MOVE_TBAR:
	tbar_pos = (tbar_pos + 1) % wxNumberOf(tbar_pos_circulate);
	fflush(stdout);
	hello_frame->SetToolBar(hello_frame->GetToolBar(),
				tbar_pos_circulate[tbar_pos]);
	break;
    case TAG_CHECK:
	rotate_tbar->Enable(!event.Checked());
	break;
    case TAG_RADIO:
	(*twin) << "RadioBox: "
		<< ((wxRadioBox*)item)->GetLabel(event.commandInt) << "\n";
	break;
    case TAG_CHOICE:
	(*twin) << "Choice: " << event.commandString << "\n";
	break;
    case TAG_SLIDER:
	gauge->SetValue(event.commandInt);
	break;
    default:
	break;
    }
}

void HelloPanel::OnDefaultAction(wxItem *item)
{
    switch (long(item->GetClientData())) {
    case TAG_SINGLETEXT:
	(*twin) << "SingleText now: " << ((wxText*)item)->GetValue() << "\n" ;
	break;
    case TAG_LIST:
	(*twin) << "ListBox: "
		<< ((wxListBox*)item)->GetStringSelection() << "\n";
	break;
    default:
	break;
    }   
}

void HelloPanel::OnItemLeftClick(wxItem *item, int WXUNUSED(x),
				 int WXUNUSED(y), int WXUNUSED(keys))
{
    // change select state
    item->SelectItem(!item->IsSelected());
    // notify on status line
    hello_frame->SetStatusText("OnItemLeftClick", 0);
}

void HelloPanel::OnItemRightClick(wxItem *WXUNUSED(item), int WXUNUSED(x),
				  int WXUNUSED(y), int WXUNUSED(keys))
{
    hello_frame->SetStatusText("OnItemRightClick", 0);
}

void HelloPanel::OnItemSelect(wxItem *WXUNUSED(item), Bool select)
{
    if (select)	hello_frame->SetStatusText("OnItemSelect: selected", 1);
    else	hello_frame->SetStatusText("OnItemSelect: unselected", 1);
};

//-----------------------------------------------------------------------------
// MyCanvas implementation
//-----------------------------------------------------------------------------

void MyCanvas::OnChar(wxKeyEvent& event)
{
    // rectangle for refreshing the arc - slightly larger than the arc
    wxRectangle rect;
    rect.x      = LogicalToDeviceX(49);
    rect.y      = LogicalToDeviceY(249);
    rect.width  = LogicalToDeviceXRel(152);
    rect.height = LogicalToDeviceYRel(102);

    switch (event.KeyCode()) {
    case '1': alpha1 += 15; if (alpha1 > 360) alpha1 = 15;
	      Refresh(TRUE, &rect);
	      break;
    case '2': alpha2 += 15; if (alpha2 > 360) alpha2 = 15;
	      Refresh(TRUE, &rect);
	      break;
    case 'x': { double tmp = alpha2; alpha2 = alpha1; alpha1 = tmp; }
	      Refresh(TRUE, &rect);
	      break;
    }
    if (event.KeyCode()=='1' || event.KeyCode()=='2' || event.KeyCode()=='x') {
	char help[80];
	sprintf(help, "Angles = (%f, %f)", alpha1, alpha2);
	hello_frame->SetStatusText(help);
    } else if (32 <= event.KeyCode() && event.KeyCode() <= 255) {
	char buf[2]; buf[0] = (char)event.KeyCode(); buf[1] = '\0';
	hello_frame->SetStatusText(buf, 1);
    } else {
	hello_frame->SetStatusText(NULL, 1);
    }
    // Process the default behaviour
    wxCanvas::OnChar(event);
}

void MyCanvas::OnEvent(wxMouseEvent& event)
{
    static float    xpos = -1, ypos = -1;
    float           x, y;

    event.Position(&x, &y);

    if (event.RightDown()) {
	PopupMenu(popup, x, y);
    } else if (xpos>-1 && ypos>-1 && event.Dragging() && event.LeftIsDown()) {
	SetPen(wxBLACK_PEN);
	SetBrush(wxTRANSPARENT_BRUSH);
	DrawLine(xpos, ypos, x, y);
    }
    xpos = x;
    ypos = y;
}

void MyCanvas::OnPaint(void)
{
//  int vx, vy, mx, my;
//  ViewStart(&vx, &vy);
//  GetScrollUnitsPerPage(&mx, &my);
  
//  wxUpdateIterator upd(this);
  
//  while (upd) {
//      char buf[100];
//      sprintf(buf, "Canvas: update %3d %3d (%3d %3d) size %3d x %3d\n",
//   	        upd.GetX(), upd.GetY(), upd.GetX() + vx*mx, upd.GetY() + vy*my,
//   	        upd.GetW(), upd.GetH());
//      (*twin) << buf;
//      upd++;
//  }
    ScaleGDIClasses(scale_gdi_classes);
    hello_frame->Draw(*(GetDC()));
}

//-----------------------------------------------------------------------------
// Timer notify proc
//-----------------------------------------------------------------------------

void MyTimer::Notify(void)
{
    (*twin) << "Timer went!\n";
}

//-----------------------------------------------------------------------------
// callback functions
//-----------------------------------------------------------------------------

static void menu_callback(wxMenu& menu, wxCommandEvent& ev)
{
    hello_frame->SetStatusText(menu.GetLabel(ev.GetSelection()));
}

//-----------------------------------------------------------------------------
// demo tool bar
//-----------------------------------------------------------------------------

Bool MyToolBar::OnLeftClick(int toolIndex, Bool toggled)
{
    switch (toolIndex) {
    case TEST_TB_LOAD:
	hello_frame->OnMenuCommand(TEST_LOAD);
	hello_frame->SetStatusText(NULL);
	break;
    case TEST_TB_SAVEAS:
	hello_frame->OnMenuCommand(TEST_SAVEAS);
	hello_frame->SetStatusText(NULL);
	break;
    case TEST_TB_DEBUG:
#if DEBUG && USE_MEMORY_TRACING
	TRACE("+++ Start memory log +++\n\n");
	wxDebugContext::Dump();
	TRACE("Statistics:\n");
	wxDebugContext::PrintStatistics();
	TRACE("+++ done +++\n");
	wxDebugContext::SetCheckpoint();
#endif
	break;
    case TEST_TB_CUT:
    case TEST_TB_COPY:
    case TEST_TB_PASTE:
	ToggleTool(TEST_TB_CUT,   (toolIndex==TEST_TB_CUT   ? toggled : FALSE));
	ToggleTool(TEST_TB_COPY,  (toolIndex==TEST_TB_COPY  ? toggled : FALSE));
	ToggleTool(TEST_TB_PASTE, (toolIndex==TEST_TB_PASTE ? toggled : FALSE));
	break;
    case TEST_TB_EMODE:
	// invert edit mode
	hello_panel->SetUserEditMode(toggled);
	hello_frame->SetStatusText(NULL, 0);
	hello_frame->SetStatusText(NULL, 1);
	break;
    case TEST_TB_SCALE: {
	// toggle scaling of wxDCs
	wxDC* dc = canvas->GetDC();
	dc->ScaleGDIClasses(scale_gdi_classes=toggled);
	dc->Clear();
	hello_frame->Draw(*dc);
	} break;
    default:
	break;
    }
    return TRUE;
}

void MyToolBar::OnMouseEnter(int toolIndex)
{
    static char* MyToolBarText[] = {
	"Load File", "Save File as ...", "Cut", "Copy", "Paste", "Undo",
	"Debug Memory", "Toggle User Edit Mode", "Toggle GDI Classes Scaling"
    };

    hello_frame->SetStatusText(toolIndex == -1 ?
			       "Hello wxWindows" : MyToolBarText[toolIndex]);
}

static wxToolBar *MakeToolBar(void)
{
    wxToolBar *toolbar = DEBUG_NEW MyToolBar(hello_frame);

    // The Xt toolbar stores references for the bitmaps
#if USE_XT_TOOLBAR
    wxBitmap file_bm(file_xpm), disk_bm(disk_xpm), cut_bm(cut_xpm),
	copy_bm(copy_xpm), paste_bm(paste_xpm), undo_bm(undo_xpm),
	debug_bm(debug_xpm), clamp_bm(clamp_xpm), scale_bm(scale_xpm);
#define REF(x) &(x ## _bm)
#else
#define REF(x) new wxBitmap(x ## _xpm)
#endif

    toolbar->SetMargins(4, 2);
    toolbar->AddTool(TEST_TB_LOAD,   REF(file));
    toolbar->AddTool(TEST_TB_SAVEAS, REF(disk));
    toolbar->Tab(10);
    toolbar->AddTool(TEST_TB_CUT,    REF(cut),   NULL, TRUE);
    toolbar->AddTool(TEST_TB_COPY,   REF(copy),  NULL, TRUE);
    toolbar->AddTool(TEST_TB_PASTE,  REF(paste), NULL, TRUE);
    toolbar->Tab(10);
    toolbar->AddTool(TEST_TB_UNDO,   REF(undo));
    toolbar->Tab(10);
    toolbar->AddTool(TEST_TB_DEBUG,  REF(debug));
    toolbar->Tab(10);
    toolbar->AddTool(TEST_TB_EMODE,  REF(clamp), NULL, TRUE);
    toolbar->Tab(10);
    toolbar->AddTool(TEST_TB_SCALE,  REF(scale), NULL, TRUE);
    toolbar->ToggleTool(TEST_TB_SCALE, scale_gdi_classes);

    return toolbar;
}

//-----------------------------------------------------------------------------
// demo menu bar
//-----------------------------------------------------------------------------

static wxMenuBar *MakeMenuBar(void)
{
    wxMenuBar *menubar      = DEBUG_NEW wxMenuBar;
    wxMenu    *file_menu    = DEBUG_NEW wxMenu;
    wxMenu    *timer_menu   = DEBUG_NEW wxMenu;
    wxMenu    *canvas_menu  = DEBUG_NEW wxMenu;
    wxMenu    *options_menu = DEBUG_NEW wxMenu;
    wxMenu    *help_menu    = DEBUG_NEW wxMenu;
    wxMenu    *cursor_menu  = DEBUG_NEW wxMenu;
    wxMenu    *scale_menu   = DEBUG_NEW wxMenu;

    file_menu->Append(TEST_NEW,		"&New\tCtrl+N", "Clear text window");
    file_menu->Append(TEST_LOAD,	"&Load\tCtrl+L", "Load textfile");
    file_menu->Append(TEST_SAVE,	"&Save\tCtrl+S", "Save textfile");
    file_menu->Append(TEST_SAVEAS,	"Save &As\tCtrl+A",
		      			"Save textfile as ...");
    file_menu->AppendSeparator();
    file_menu->Append(TEST_PRINTEPS,	"Print", "Print Canvas");
    file_menu->AppendSeparator();
    file_menu->Append(TEST_QUIT,	"&Quit\tMeta-X", "Quit test program");

    timer_menu->Append(TEST_TIMERON,	"Timer &on",    "Turn timer on");
    timer_menu->Append(TEST_TIMEROFF,	"Timer o&ff",   "Turn timer off");
    timer_menu->Enable(TEST_TIMEROFF,	FALSE);
    timer_menu->AppendSeparator();
    timer_menu->Append(TEST_CHECKABLE,	"&Toggle item", "Checkable item", TRUE);

    scale_menu->Append(TEST_TWIPS,	"&Twips", "Twips Scale");
    scale_menu->Append(TEST_LOMETRIC,	"&10th mm", "Metric Scale (0.1 mm)");
    scale_menu->Append(TEST_METRIC,	"&Metric", "Metric Scale (1 mm)");
    scale_menu->Append(TEST_POINT,	"&Point", "Point Scale");
    scale_menu->Append(TEST_NORMAL,	"&Normal size\tCtrl-R", "Pixel Scale");
    scale_menu->AppendSeparator();
    scale_menu->Append(TEST_ZOOM,	"&Zoom...\tCtrl-Z",
		       			"Zoom by specified amount");
	
    cursor_menu->Append(TEST_CURSOR_ARROW,		"Arrow",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_BASED_ARROW_DOWN,	"Based Down",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_BASED_ARROW_UP,	"Based Up",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_BULLSEYE,		"Bulls Eye",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_CROSS,		"Cross",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_CROSS_REVERSE,	"Cross Reverse",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_DOUBLE_ARROW,	"Double Arrow",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_HAND,		"Hand",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_IBEAM,		"IBeam",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_LEFT_BUTTON,	"Left Button",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_MAGNIFIER,		"Magnifier",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_MIDDLE_BUTTON,	"Middle Button",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_NO_ENTRY,		"No Entry",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_PAINT_BRUSH,	"Paint Brush",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_PENCIL,		"Pencil",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_POINT_LEFT,		"Point Left",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_POINT_RIGHT,	"Point Right",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_QUESTION_ARROW,	"Question Arrow",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_RIGHT_BUTTON,	"Right Button",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_SIZENESW,		"Size NESW",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_SIZENS,		"Size NS",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_SIZENWSE,		"Size NWSE",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_SIZEWE,		"Size WE",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_SIZING,		"Sizing",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_SPRAYCAN,		"Spraycan",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_WAIT,		"Wait",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_WATCH,		"Watch",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_CHAR,		"Char",
							"Change Canvas Cursor");
    cursor_menu->Append(TEST_CURSOR_BLANK,		"Blank",
							"Change Canvas Cursor");

    canvas_menu->Append(TEST_SCALE,	"&Scale Picture",
					scale_menu, "Scale Picture");
    canvas_menu->Append(TEST_CURSOR,	"&Set Cursor",
					cursor_menu, "Set Cursor");

    options_menu->Append(TEST_CHANGE_COLOUR, "Change &Colour",
			 		     "Popup Colour Dialog");
    options_menu->Append(TEST_CHANGE_FONT,   "Change &Font",
					     "Popup Font Dialog");

    help_menu->Append(TEST_ABOUT, "&About",  "About Test wxWindows");

    menubar->Append(file_menu,		"&File");
    menubar->Append(timer_menu,		"&Timer");
    menubar->Append(canvas_menu,	"&Canvas");
    menubar->Append(options_menu,	"&Options");
    menubar->Append(help_menu,		"&Help");

    return menubar;
}
