/* -*- C++ -*-
 * File:	tiff-fr.h
 * Purpose:	TIFF viewing frame for wxWindows class library
 * Author:	Wolfram Gloger
 * Created:	1996
 * Updated:	
 */

#ifndef _TIFF_FR_H
#define _TIFF_FR_H

#ifdef __GNUG__
#pragma interface
#endif

class TiffCanvas: public wxCanvas
{
public:
    TiffCanvas(wxFrame *frame, int x, int y, int w, int h,
			   long style = wxRETAINED);
    ~TiffCanvas(void) ;
    void OnPaint(void);
    void OnEvent(wxMouseEvent& event);
    void OnChar(wxKeyEvent& event);
    void OnScroll(wxCommandEvent& event);
};

class TiffFrame: public wxFrame
{
public:
	TiffFrame(wxFrame *parent, char *title, const char *filename,
			  int x, int y, int w, int h);
	~TiffFrame();
	char *GetFileName() { return file_name; }
	void SetName(char *name);
	int LoadTiff(const char *filename);
	void UpdateCanvas();
private:
	char *file_name;
	wxColourMap *cmap;
	TiffCanvas *canvas;
	int img_resx, img_resy;
	unsigned char *bm;
	int map_size;
	unsigned char *map_r, *map_g, *map_b;
};

#endif /* _TIFF_FR_H */

/*
 * Local variables:
 * tab-width: 4
 * End:
 */
