/*								-*- C++ -*-
 * $Id: UTL_busycursor.cpp,v 1.3 1997-01-30 09:56:02+01 mho Exp $
 *
 * Purpose: busy cursor
 *
 * Authors: Markus Holzem and Julian Smart
 *
 * Copyright: (C) 1995, AIAI, University of Edinburgh (Julian)
 * Copyright: (C) 1995, GNU (Markus)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Additionally everyone using this library has to announce it with:
 *
 *   This software uses the wxWindows-Xt GUI library
 *   (C) Markus Holzem, available via
 *       ftp://ftp.aiai.ed.ac.uk/pub/packages/wxwin/ports/xt
 */

#define  Uses_wxWindow
#include "wx.h"

void wxBeginBusyCursor(wxCursor *cursor)
{
    if ( ++wxCursorBusy == 1) {
	if (!cursor)
	    cursor = wxHOURGLASS_CURSOR;
	
	wxNode *node;
	for (node=wxTopLevelFrames.First(); node; node=node->Next())
	    ((wxWindow*)(node->Data()))->SetBusyCursor(cursor);
	wxFlushEvents();
    }
}

void wxEndBusyCursor(void)
{
    if (!wxCursorBusy)
	return;

    if ( --wxCursorBusy == 0 ) {
	wxNode *node;
	for (node=wxTopLevelFrames.First(); node; node=node->Next())
	    ((wxWindow*)(node->Data()))->SetBusyCursor((wxCursor*)NULL);
	wxFlushEvents();
    }
}

Bool wxIsBusy(void)
{
    return (wxCursorBusy != 0);
}

