/*
 * File:	GLCanvas.h
 * Purpose:	wxWindows interface for OpenGL using the GLX extension
 * Author:	Wolfram Gloger
 * Created:	1995
 * Updated:     Jul 1996 for wx-Xt 1.65
 */

#ifndef _GL_CANV_H
#define _GL_CANV_H

#include <GL/glx.h>

class GLCanvas: public wxCanvas
{
public:
    GLCanvas(wxWindow *parent, int x, int y, int w, int h,
	     long style = 0, char *name = "GLCanvas", int *attrib_list = 0);
    ~GLCanvas(void);
    int  GLSetCurrent(void);
    void GLSwapBuffers(void);
    void GLSetColour(const char *col);
    Bool IsRGBA() { return (Bool)is_rgba; }
protected:
    GLXContext glx_cx;
private:
    GLboolean is_rgba;
};

#endif
